if (!isGeneric("colSums"))
    setGeneric("colSums",
               function(x, na.rm=FALSE, dims=1)
               standardGeneric("colSums"))

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("colSums",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1) 
              stop("invalid `dims'")
          n <- prod(dn[1:dims])
          dn <- dn[-(1:dims)]
          x <- .Call("colSums", x, getNativeStorageMethods(x),
                     n, prod(dn), na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[-(1:dims)]
          } else names(x) <- dimnames(x)[[dims + 1]]
          x
      })

if (!isGeneric("colMeans"))
    setGeneric("colMeans",
               function(x, na.rm, dims)
               standardGeneric("colMeans"))

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("colMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1) 
              stop("invalid `dims'")
          n <- prod(dn[1:dims])
          dn <- dn[-(1:dims)]
          x <- .Call("colMeans", x, getNativeStorageMethods(x),
                     n, prod(dn), na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[-(1:dims)]
          } else names(x) <- dimnames(x)[[dims + 1]]
          x
      })

if (!isGeneric("rowSums"))
    setGeneric("rowSums",
               function(x, na.rm, dims)
               standardGeneric("rowSums"))

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("rowSums",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1) 
              stop("invalid `dims'")
          p <- prod(dn[-(1:dims)])
          dn <- dn[1:dims]
          x <- .Call("rowSums", x, getNativeStorageMethods(x),
                     prod(dn), p, na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[1:dims]
          } else names(x) <- dimnames(x)[[1]]
          x
      })

if (!isGeneric("rowMeans"))
    setGeneric("rowMeans",
               function(x, na.rm, dims)
               standardGeneric("rowMeans"))

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing",
                    dims = "missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=1)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=FALSE, dims=dims)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    dims="missing"),
          function(x, na.rm, dims)
      {
          callGeneric(x, na.rm=na.rm, dims=1)
      })

setMethod("rowMeans",
          signature(x="externalVectorWithStorage",
                    na.rm="logical",
                    dims="numeric"),
          function(x, na.rm, dims)
      {
          if (length(dn <- dim(x)) < 2)
              stop("`x' must be an external array of at least two dimensions")
          if (dims < 1 || dims > length(dn) - 1) 
              stop("invalid `dims'")
          p <- prod(dn[-(1:dims)])
          dn <- dn[1:dims]
          x <- .Call("rowMeans", x, getNativeStorageMethods(x),
                     prod(dn), p, na.rm,
                     PACKAGE="externalVector")
          if (length(dn) > 1) {
              dim(x) <- dn
              dimnames(x) <- dimnames(x)[1:dims]
          } else names(x) <- dimnames(x)[[1]]
          x
      })

setMethod("apply",
          signature(X="externalVector"),
          function (X, MARGIN, FUN, ...)  
          callGeneric(as.Rmatrix(X), MARGIN, FUN, ...))

setMethod("log",
          signature(x="externalVectorWithStorage"),
          function (x, base) 
      {
          klass <- class(defaultElement(x))
          if (!(klass %in% c("logical", "integer", "numeric",
                             "complex")))
              stop("Non-numeric argument to mathematical function")
          if (missing(base)) {
              if (length(x) == 0)
                  return(numeric(0))
              ans <- rebind(x,
                            type = if (klass == "complex") {
                                complex(1)
                            } else numeric(1))
              .Call("externalVectorMath", "log",
                    x, getNativeStorageMethods(x@storage),
                    ans, getNativeStorageMethods(ans@storage),
                    PACKAGE="externalVector")
          } else {
              if (length(base) == 0)
                  stop("illegal 2nd arg of length 0")
              if (length(x) == 0)
                  return(numeric(0))
              if (is(base, "externalVectorWithStorage")) {
                  klass <- class(defaultElement(base))
                  if (!(klass %in% c("logical", "integer", "numeric",
                                     "complex")))
                      stop("Non-numeric argument to mathematical function")
                  ans <- .Call('externalVectorLog', x,
                               base,
                               PACKAGE="externalVector")
                  if (is(ans, "externalStorage")) {
                      n <- length(x)
                      x@storage <- ans
                      if (length(base) > n) {
                          dim(x) <- dim(base)
                          dimnames(x) <- dimnames(base)
                          names(x) <- names(base)
                      }
                      x
                  } else ans
              } else {
                  klass <- class(base)
                  if (!(klass %in% c("logical", "integer", "numeric",
                                     "complex")))
                      stop("Non-numeric argument to mathematical function")
                  ans <- .Call('externalVectorLog', x,
                               base,
                               PACKAGE="externalVector")
                  if (is(ans, "externalStorage")) {
                      n <- ans@length
                      if (length(x) == n) {
                          x@storage <- ans
                          x
                      } else {
                          base@storage <- ans
                          base
                      }
                  } else {
                      ans
                  }
              }
          }
      })

setMethod("lapply",
          signature(X="externalVector"),
          function (X, FUN, ...) 
      {
          X <- force(X)
          callNextMethod()
      })

setMethod("lapply",
          signature(X="externalVectorWithStorage"),
          function (X, FUN, ...) 
      {
          FUN <- match.fun(FUN)
          mcall <- match.call()
          mcall$FUN <- NULL
          mcall[[1]] <- FUN
          names(mcall)[which(names(mcall) == "X")] <- ""
          rval <- .Call("externalVector_lapply",
                        X, length(X), mcall, parent.frame(),
                        PACKAGE="externalVector")
          names(rval) <- names(X)
          return(rval)
      })

setMethod("sapply",
          signature(X="externalVector"),
          function (X, FUN, ..., simplify, USE.NAMES) 
      {
          FUN <- match.fun(FUN)
          answer <- lapply(X, FUN, ...)
          if (USE.NAMES && is.character(defaultElement(X)) &&
              is.null(names(answer))) 
              names(answer) <- as.Rvector(X)
          if (simplify && length(answer) &&
              length(common.len <- unique(unlist(lapply(answer, 
                                                        length)))) == 1) {
              if (common.len == 1) 
                  unlist(answer, recursive = FALSE)
              else if (common.len > 1) 
                  array(unlist(answer, recursive = FALSE),
                        dim = c(common.len, length(X)),
                        dimnames = if (!(is.null(n1 <- names(answer[[1]])) & 
                                         is.null(n2 <- names(answer)))) {
                            list(n1, n2)
                        })
              else answer
          } else answer
      })

setMethod("mean",
          signature(x="externalVector"),
          function (x, trim = 0, na.rm = FALSE, ...) 
          mean(as.Rvector(as.vector(x)), trim, na.rm, ...))

setMethod("median",
          signature(x="externalVector"),
          function (x, na.rm) 
          mean(as.Rvector(as.vector(x)), na.rm))
