\name{as.Rvector}
\alias{as.Rvector}
\alias{as.Rvector,logical-method}
\alias{as.Rvector,integer-method}
\alias{as.Rvector,numeric-method}
\alias{as.Rvector,complex-method}
\alias{as.Rvector,character-method}
\alias{as.Rvector,list-method}
\title{ convert an object to one of the most appropriate R basic vector }
\description{
  \code{as.Rvector}, a generic, attempts to coerce its argument into a
  basic R vector of a convenient mode. All attributes of \code{x} are
  preserved.
  
  Default methods are provided for basic R vectors which are returned
  unchanged.
}
\usage{
as.Rvector(x)
}
\arguments{
  \item{x}{ An object }
}
\details{
  This preserves all the non-slot attributes of the object \code{x}
  when converting to a basic R vector. In addition, if any of
  \code{dim(x)}, \code{dimnames(x)}, \code{names(x)} is not
  \code{NULL}, the corresponding attribute in the result is also set.
}
\value{
  The value is a basic R vector of mode "logical", "integer",
  "numeric", "complex", "character" or "list".
}
\seealso{ \code{\link{as.vector}} for converting an object to an
  appropriate vector with all attributes removed. }
\examples{
x <- 1:2
names(x) <- letters[1:2]
as.vector(x)
as.Rvector(x)
}
\keyword{classes}
